summaryrefslogtreecommitdiffstats
path: root/kubernetes/config/docker/init/src/config/dcaegen2/heat
diff options
context:
space:
mode:
Diffstat (limited to 'kubernetes/config/docker/init/src/config/dcaegen2/heat')
-rwxr-xr-xkubernetes/config/docker/init/src/config/dcaegen2/heat/OOM-openrc-v2.sh34
-rwxr-xr-xkubernetes/config/docker/init/src/config/dcaegen2/heat/OOM-openrc-v3.sh41
-rwxr-xr-xkubernetes/config/docker/init/src/config/dcaegen2/heat/entrypoint.sh158
-rw-r--r--kubernetes/config/docker/init/src/config/dcaegen2/heat/onap_dcae.env100
-rw-r--r--kubernetes/config/docker/init/src/config/dcaegen2/heat/onap_dcae.yaml483
5 files changed, 816 insertions, 0 deletions
diff --git a/kubernetes/config/docker/init/src/config/dcaegen2/heat/OOM-openrc-v2.sh b/kubernetes/config/docker/init/src/config/dcaegen2/heat/OOM-openrc-v2.sh
new file mode 100755
index 0000000000..3313ef6793
--- /dev/null
+++ b/kubernetes/config/docker/init/src/config/dcaegen2/heat/OOM-openrc-v2.sh
@@ -0,0 +1,34 @@
+#!/usr/bin/env bash
+# To use an OpenStack cloud you need to authenticate against the Identity
+# service named keystone, which returns a **Token** and **Service Catalog**.
+# The catalog contains the endpoints for all services the user/tenant has
+# access to - such as Compute, Image Service, Identity, Object Storage, Block
+# Storage, and Networking (code-named nova, glance, keystone, swift,
+# cinder, and neutron).
+#
+# *NOTE*: Using the 2.0 *Identity API* does not necessarily mean any other
+# OpenStack API is version 2.0. For example, your cloud provider may implement
+# Image API v1.1, Block Storage API v2, and Compute API v2.0. OS_AUTH_URL is
+# only for the Identity API served through keystone.
+export OS_AUTH_URL=OPENSTACK_KEYSTONE_IP_HERE/v2.0
+# With the addition of Keystone we have standardized on the term **tenant**
+# as the entity that owns the resources.
+export OS_TENANT_ID=OPENSTACK_TENANT_ID_HERE
+export OS_TENANT_NAME="OPENSTACK_TENANT_NAME_HERE"
+# unsetting v3 items in case set
+unset OS_PROJECT_ID
+unset OS_PROJECT_NAME
+unset OS_USER_DOMAIN_NAME
+unset OS_INTERFACE
+# In addition to the owning entity (tenant), OpenStack stores the entity
+# performing the action as the **user**.
+export OS_USERNAME="OPENSTACK_USERNAME_HERE"
+# With Keystone you pass the keystone password.
+export OS_PASSWORD=OPENSTACK_PASSWORD_HERE
+# If your configuration has multiple regions, we set that information here.
+# OS_REGION_NAME is optional and only valid in certain environments.
+export OS_REGION_NAME="OPENSTACK_REGION_HERE"
+# Don't leave a blank variable, unset it if it was empty
+if [ -z "$OS_REGION_NAME" ]; then unset OS_REGION_NAME; fi
+export OS_ENDPOINT_TYPE=publicURL
+export OS_IDENTITY_API_VERSION=2 \ No newline at end of file
diff --git a/kubernetes/config/docker/init/src/config/dcaegen2/heat/OOM-openrc-v3.sh b/kubernetes/config/docker/init/src/config/dcaegen2/heat/OOM-openrc-v3.sh
new file mode 100755
index 0000000000..f8d0967fc3
--- /dev/null
+++ b/kubernetes/config/docker/init/src/config/dcaegen2/heat/OOM-openrc-v3.sh
@@ -0,0 +1,41 @@
+#!/usr/bin/env bash
+
+# To use an OpenStack cloud you need to authenticate against the Identity
+# service named keystone, which returns a **Token** and **Service Catalog**.
+# The catalog contains the endpoints for all services the user/tenant has
+# access to - such as Compute, Image Service, Identity, Object Storage, Block
+# Storage, and Networking (code-named nova, glance, keystone, swift,
+# cinder, and neutron).
+#
+# *NOTE*: Using the 3 *Identity API* does not necessarily mean any other
+# OpenStack API is version 3. For example, your cloud provider may implement
+# Image API v1.1, Block Storage API v2, and Compute API v2.0. OS_AUTH_URL is
+# only for the Identity API served through keystone.
+export OS_AUTH_URL=OPENSTACK_KEYSTONE_IP_HERE/v3
+
+# With the addition of Keystone we have standardized on the term **project**
+# as the entity that owns the resources.
+export OS_PROJECT_ID=OPENSTACK_TENANT_ID_HERE
+export OS_PROJECT_NAME="OPENSTACK_TENANT_NAME_HERE"
+export OS_USER_DOMAIN_NAME="Default"
+if [ -z "$OS_USER_DOMAIN_NAME" ]; then unset OS_USER_DOMAIN_NAME; fi
+
+# unset v2.0 items in case set
+unset OS_TENANT_ID
+unset OS_TENANT_NAME
+
+# In addition to the owning entity (tenant), OpenStack stores the entity
+# performing the action as the **user**.
+export OS_USERNAME="OPENSTACK_USERNAME_HERE"
+
+# With Keystone you pass the keystone password.
+export OS_PASSWORD=OPENSTACK_PASSWORD_HERE
+
+# If your configuration has multiple regions, we set that information here.
+# OS_REGION_NAME is optional and only valid in certain environments.
+export OS_REGION_NAME="OPENSTACK_REGION_HERE"
+# Don't leave a blank variable, unset it if it was empty
+if [ -z "$OS_REGION_NAME" ]; then unset OS_REGION_NAME; fi
+
+export OS_INTERFACE=public
+export OS_IDENTITY_API_VERSION=3 \ No newline at end of file
diff --git a/kubernetes/config/docker/init/src/config/dcaegen2/heat/entrypoint.sh b/kubernetes/config/docker/init/src/config/dcaegen2/heat/entrypoint.sh
new file mode 100755
index 0000000000..85c5ee2b13
--- /dev/null
+++ b/kubernetes/config/docker/init/src/config/dcaegen2/heat/entrypoint.sh
@@ -0,0 +1,158 @@
+#/bin/bash
+set -x
+
+function configure_dns_designate() {
+ # Check whether the SIMPLEDEMO_ONAP_ORG_ZONE_ID exists
+ EXISTING_ZONES=`openstack zone list -f=yaml -c=name | awk ' { print$3 } '`
+ if [[ $EXISTING_ZONES =~ (^|[[:space:]])$SIMPLEDEMO_ONAP_ORG_ZONE_NAME($|[[:space:]]) ]]
+ then
+ echo "Zone $SIMPLEDEMO_ONAP_ORG_ZONE_NAME already exist, retrieving it's ID."
+ SIMPLEDEMO_ONAP_ORG_ZONE_ID=`openstack zone list -f=yaml --name=simpledemo.onap.org. -c=id | awk ' { print $3 } '`
+ echo "Zone $SIMPLEDEMO_ONAP_ORG_ZONE_NAME id is: $SIMPLEDEMO_ONAP_ORG_ZONE_ID"
+ else
+ echo "Zone $SIMPLEDEMO_ONAP_ORG_ZONE_NAME doens't exist, creating ..."
+ SIMPLEDEMO_ONAP_ORG_ZONE_ID=`openstack zone create --email=oom@onap.org --description="DNS zone bridging DCAE and OOM" --type=PRIMARY $SIMPLEDEMO_ONAP_ORG_ZONE_NAME -f=yaml -c id | awk '{ print $2} '`
+
+ echo "Create recordSet for $SIMPLEDEMO_ONAP_ORG_ZONE_NAME"
+ openstack recordset create --type=A --ttl=10 --records=$NODE_IP $SIMPLEDEMO_ONAP_ORG_ZONE_ID vm1.aai
+ openstack recordset create --type=A --ttl=10 --records=$NODE_IP $SIMPLEDEMO_ONAP_ORG_ZONE_ID vm1.sdc
+ openstack recordset create --type=A --ttl=10 --records=$NODE_IP $SIMPLEDEMO_ONAP_ORG_ZONE_ID vm1.mr
+ openstack recordset create --type=A --ttl=10 --records=$NODE_IP $SIMPLEDEMO_ONAP_ORG_ZONE_ID vm1.policy
+ openstack recordset create --type=A --ttl=10 --records=$NODE_IP $SIMPLEDEMO_ONAP_ORG_ZONE_ID vm1.openo
+
+ echo "Create CNAMEs for $SIMPLEDEMO_ONAP_ORG_ZONE_NAME"
+ # AAI
+ openstack recordset create --type=CNAME --ttl=86400 --records=vm1.aai.simpledemo.onap.org. $SIMPLEDEMO_ONAP_ORG_ZONE_ID c1.vm1.aai.simpledemo.onap.org.
+ openstack recordset create --type=CNAME --ttl=86400 --records=vm1.aai.simpledemo.onap.org. $SIMPLEDEMO_ONAP_ORG_ZONE_ID c2.vm1.aai.simpledemo.onap.org.
+ openstack recordset create --type=CNAME --ttl=86400 --records=vm1.aai.simpledemo.onap.org. $SIMPLEDEMO_ONAP_ORG_ZONE_ID c3.vm1.aai.simpledemo.onap.org.
+ openstack recordset create --type=CNAME --ttl=86400 --records=vm1.aai.simpledemo.onap.org. $SIMPLEDEMO_ONAP_ORG_ZONE_ID aai.api.simpledemo.onap.org.
+ openstack recordset create --type=CNAME --ttl=86400 --records=vm1.aai.simpledemo.onap.org. $SIMPLEDEMO_ONAP_ORG_ZONE_ID aai.ui.simpledemo.onap.org.
+ openstack recordset create --type=CNAME --ttl=86400 --records=vm1.aai.simpledemo.onap.org. $SIMPLEDEMO_ONAP_ORG_ZONE_ID aai.searchservice.simpledemo.onap.org.
+
+ # SDC
+ openstack recordset create --type=CNAME --ttl=86400 --records=vm1.sdc.simpledemo.onap.org. $SIMPLEDEMO_ONAP_ORG_ZONE_ID c1.vm1.sdc.simpledemo.onap.org.
+ openstack recordset create --type=CNAME --ttl=86400 --records=vm1.sdc.simpledemo.onap.org. $SIMPLEDEMO_ONAP_ORG_ZONE_ID c2.vm1.sdc.simpledemo.onap.org.
+ openstack recordset create --type=CNAME --ttl=86400 --records=vm1.sdc.simpledemo.onap.org. $SIMPLEDEMO_ONAP_ORG_ZONE_ID c3.vm1.sdc.simpledemo.onap.org.
+ openstack recordset create --type=CNAME --ttl=86400 --records=vm1.sdc.simpledemo.onap.org. $SIMPLEDEMO_ONAP_ORG_ZONE_ID c4.vm1.sdc.simpledemo.onap.org.
+
+ # Policy
+ openstack recordset create --type=CNAME --ttl=86400 --records=vm1.policy.simpledemo.onap.org. $SIMPLEDEMO_ONAP_ORG_ZONE_ID c1.vm1.policy.simpledemo.onap.org.
+ openstack recordset create --type=CNAME --ttl=86400 --records=vm1.policy.simpledemo.onap.org. $SIMPLEDEMO_ONAP_ORG_ZONE_ID c2.vm1.policy.simpledemo.onap.org.
+ openstack recordset create --type=CNAME --ttl=86400 --records=vm1.policy.simpledemo.onap.org. $SIMPLEDEMO_ONAP_ORG_ZONE_ID c3.vm1.policy.simpledemo.onap.org.
+ openstack recordset create --type=CNAME --ttl=86400 --records=vm1.policy.simpledemo.onap.org. $SIMPLEDEMO_ONAP_ORG_ZONE_ID c4.vm1.policy.simpledemo.onap.org.
+ openstack recordset create --type=CNAME --ttl=86400 --records=vm1.policy.simpledemo.onap.org. $SIMPLEDEMO_ONAP_ORG_ZONE_ID c5.vm1.policy.simpledemo.onap.org.
+ openstack recordset create --type=CNAME --ttl=86400 --records=vm1.policy.simpledemo.onap.org. $SIMPLEDEMO_ONAP_ORG_ZONE_ID c6.vm1.policy.simpledemo.onap.org.
+ openstack recordset create --type=CNAME --ttl=86400 --records=vm1.policy.simpledemo.onap.org. $SIMPLEDEMO_ONAP_ORG_ZONE_ID c7.vm1.policy.simpledemo.onap.org.
+ openstack recordset create --type=CNAME --ttl=86400 --records=vm1.policy.simpledemo.onap.org. $SIMPLEDEMO_ONAP_ORG_ZONE_ID c8.vm1.policy.simpledemo.onap.org.
+ openstack recordset create --type=CNAME --ttl=86400 --records=vm1.policy.simpledemo.onap.org. $SIMPLEDEMO_ONAP_ORG_ZONE_ID policy.api.simpledemo.onap.org.
+
+ # MR
+ openstack recordset create --type=CNAME --ttl=86400 --records=vm1.mr.simpledemo.onap.org. $SIMPLEDEMO_ONAP_ORG_ZONE_ID ueb.api.simpledemo.onap.org.
+
+ # Open-O
+ openstack recordset create --type=CNAME --ttl=86400 --records=vm1.openo.simpledemo.onap.org. $SIMPLEDEMO_ONAP_ORG_ZONE_ID msb.api.simpledemo.onap.org.
+ openstack recordset create --type=CNAME --ttl=86400 --records=vm1.openo.simpledemo.onap.org. $SIMPLEDEMO_ONAP_ORG_ZONE_ID mvim.api.simpledemo.onap.org.
+ openstack recordset create --type=CNAME --ttl=86400 --records=vm1.openo.simpledemo.onap.org. $SIMPLEDEMO_ONAP_ORG_ZONE_ID vnfsdk.api.simpledemo.onap.org.
+ openstack recordset create --type=CNAME --ttl=86400 --records=vm1.openo.simpledemo.onap.org. $SIMPLEDEMO_ONAP_ORG_ZONE_ID vfc.api.simpledemo.onap.org.
+ openstack recordset create --type=CNAME --ttl=86400 --records=vm1.openo.simpledemo.onap.org. $SIMPLEDEMO_ONAP_ORG_ZONE_ID uui.api.simpledemo.onap.org.
+ openstack recordset create --type=CNAME --ttl=86400 --records=vm1.openo.simpledemo.onap.org. $SIMPLEDEMO_ONAP_ORG_ZONE_ID esr.api.simpledemo.onap.org.
+ fi
+}
+
+function monitor_nginx_node_ip() {
+ echo "Monitor DCAE nginx host ip..."
+ while true
+ do
+ # Get the Kubernetes Node IP hosting the DCAE NGINX pod
+ NODE_IP=`kubectl get services dcaegen2 -o jsonpath='{.status.loadBalancer.ingress[0].ip}'`
+
+ # Lookup the IP for the first DNS record entry
+ # Assumption is made all entried are sharing the same IP, hence if the first one is different
+ # We update the whole table
+ CURRENT_NODE_IP=`openstack recordset list $SIMPLEDEMO_ONAP_ORG_ZONE_ID -c records --type=A -f yaml | head -n 1 | awk ' { print $3 } '`
+
+ if [ "$NODE_IP" != "$CURRENT_NODE_IP" ]; then
+ refresh_dns_records
+ fi
+
+ # refresh every 10 seconds
+ sleep 10
+ done
+}
+
+function refresh_dns_records() {
+ echo "DCAE nginx host ip has changed, update DNS records..."
+ # Get the Kubernetes Node IP hosting the DCAE NGINX pod
+ NODE_IP=`kubectl get services dcaegen2 -o jsonpath='{.status.loadBalancer.ingress[0].ip}'`
+
+ # Update all the simpledemo record
+ SIMPLEDEMO_ONAP_ORG_RECORD_TYPE_A_IDS=`openstack recordset list $SIMPLEDEMO_ONAP_ORG_ZONE_ID --type=A -c=id -f=yaml | awk ' { print $3 } '`
+ for record_id in $SIMPLEDEMO_ONAP_ORG_RECORD_TYPE_A_IDS
+ do
+ openstack recordset set --records=$NODE_IP $SIMPLEDEMO_ONAP_ORG_ZONE_ID $record_id
+ done
+}
+
+#############################################################################################################
+# Script starts here #
+#############################################################################################################
+
+# Retrieve the namespace
+if [ "$#" -ne 1 ]; then
+ echo "Usage: $(basename $0) <namespace>"
+ exit 1
+fi
+NAMESPACE=$1
+
+# K8S variable
+MR_ZONE="$NAMESPACE-message-router"
+
+# Heat variable
+STACK_NAME="dcae"
+
+# DNS variables
+SIMPLEDEMO_ONAP_ORG_ZONE_NAME="simpledemo.onap.org."
+SIMPLEDEMO_ONAP_ORG_ZONE_ID=""
+
+# Install required packages to interfact with OpenStack CLIs
+apt update -y
+apt -y install python-pip
+pip install python-openstackclient
+pip install python-heatclient
+pip install python-designateclient
+
+# Instal kubectl commands
+apt -y install curl
+curl -LO https://storage.googleapis.com/kubernetes-release/release/$(curl -s https://storage.googleapis.com/kubernetes-release/release/stable.txt)/bin/linux/amd64/kubectl
+chmod +x ./kubectl
+mv ./kubectl /usr/local/bin/kubectl
+
+# Get the Kubernetes Node IP hosting the DCAE NGINX pod
+NODE_IP=`kubectl get services dcaegen2 -o jsonpath='{.status.loadBalancer.ingress[0].ip}'`
+
+# # Source OpenStack parameters
+if [ "OPENSTACK_API_VERSION_HERE" = "v2.0" ]
+then
+ source /opt/heat/OOM-openrc-v2.sh
+else
+ source /opt/heat/OOM-openrc-v3.sh
+fi
+
+# Create stasck if doens't exist
+EXISTING_STACKS=`openstack stack list -c 'Stack Name' -f yaml | awk '{ print $4}'`
+if ! [[ $EXISTING_STACKS =~ (^|[[:space:]])$STACK_NAME($|[[:space:]]) ]]
+then
+ # create the DCAE stack
+ openstack stack create -t /opt/heat/onap_dcae.yaml -e /opt/heat/onap_dcae.env $STACK_NAME
+
+ # wait 10 seconds to let the stack start, so the ips have been assigned.
+ sleep 10
+
+ # get the DCAE Boostrap VM ip, to configure Robot with it, for Healthcheck
+ DCAE_CONTROLLER_IP=`openstack stack output show dcae dcae_floating_ip -c output_value -f yaml | awk '{ print $2}'`
+ sed -i -e "s/DCAE_CONTROLLER_IP_HERE/$DCAE_CONTROLLER_IP/g" /opt/robot/vm_properties.py;
+fi
+
+configure_dns_designate
+
+monitor_nginx_node_ip \ No newline at end of file
diff --git a/kubernetes/config/docker/init/src/config/dcaegen2/heat/onap_dcae.env b/kubernetes/config/docker/init/src/config/dcaegen2/heat/onap_dcae.env
new file mode 100644
index 0000000000..363de40526
--- /dev/null
+++ b/kubernetes/config/docker/init/src/config/dcaegen2/heat/onap_dcae.env
@@ -0,0 +1,100 @@
+parameters:
+
+ ##############################################
+ # #
+ # Parameters used across all ONAP components #
+ # #
+ ##############################################
+
+ public_net_id: OPENSTACK_PUBLIC_NET_ID_HERE
+
+ public_net_name: OPENSTACK_PUBLIC_NET_NAME_HERE
+
+ ubuntu_1404_image: UBUNTU_14_IMAGE_NAME_HERE
+
+ ubuntu_1604_image: UBUNTU_16_IMAGE_NAME_HERE
+
+ flavor_small: OPENSTACK_FLAVOUR_SMALL_HERE
+
+ flavor_medium: OPENSTACK_FLAVOUR_MEDIUM_HERE
+
+ flavor_large: OPENSTACK_FLAVOUR_LARGE_HERE
+
+ vm_base_name: DCAE_VM_BASE_NAME_HERE
+
+ key_name: OPENSTACK_KEY_NAME_HERE
+
+ pub_key: OPENSTACK_PUB_KEY_HERE
+
+ nexus_repo: NEXUS_HTTP_REPO_HERE
+
+ nexus_docker_repo: NEXUS_DOCKER_REPO_HERE
+
+ nexus_username: NEXUS_USERNAME_HERE
+
+ nexus_password: NEXUS_PASSWORD_HERE
+
+ artifacts_version: DEMO_ARTIFACTS_VERSION_HERE
+
+ openstack_tenant_id: OPENSTACK_TENANT_ID_HERE
+
+ openstack_tenant_name: OPENSTACK_TENANT_NAME_HERE
+
+ openstack_username: OPENSTACK_USERNAME_HERE
+
+ openstack_api_key: OPENSTACK_PASSWORD_HERE
+
+ openstack_region: OPENSTACK_REGION_HERE
+
+ keystone_url: OPENSTACK_KEYSTONE_IP_HERE
+
+ cloud_env: openstack
+
+ ######################
+ # #
+ # Network parameters #
+ # #
+ ######################
+
+ dns_list: DNS_LIST_HERE
+ external_dns: EXTERNAL_DNS_HERE
+ dns_forwarder: DNS_FORWARDER_HERE
+ oam_network_cidr: NETWORK_CIDR_WITH_ONAP_ROUTE_HERE
+
+ ### Private IP addresses ###
+
+ dns_ip_addr: DNS_FORWARDER_HERE
+ dcae_ip_addr: DCAE_IP_ADDR_HERE
+
+ aai1_k8s_ip_addr: vm1.aai.simpledemo.onap.org
+ aai2_k8s_ip_addr: vm2.aai.simpledemo.onap.org
+ mr_k8s_ip_addr: vm1.mr.simpledemo.onap.org
+ sdc_k8s_ip_addr: vm1.sdc.simpledemo.onap.org
+ policy_k8s_ip_addr: vm1.policy.simpledemo.onap.org
+ openo_k8s_ip_addr: vm1.openo.simpledemo.onap.org
+
+ ###########################
+ # #
+ # Parameters used by DCAE #
+ # #
+ ###########################
+
+ dnsaas_config_enabled: DNSAAS_PROXY_ENABLE_HERE
+ dnsaas_region: DNSAAS_REGION_HERE
+ dnsaas_keystone_url: DNSAAS_KEYSTONE_URL_HERE
+ dnsaas_tenant_name: DNSAAS_TENANT_NAME_HERE
+ dnsaas_username: DNSAAS_USERNAME_HERE
+ dnsaas_password: DNSAAS_PASSWORD_HERE
+ dcae_keystone_url: DCAE_KEYSTONE_URL_HERE
+ dcae_centos_7_image: OPENSTACK_CENTOS_7_IMAGE_HERE
+ dcae_domain: DCAE_DOMAIN_HERE
+ dcae_public_key: OPENSTACK_PUB_KEY_HERE
+ dcae_private_key: OPENSTACK_PRIVATE_KEY_HERE
+
+ ################################
+ # #
+ # Docker versions and branches #
+ # #
+ ################################
+
+ dcae_docker: DCAE_DOCKER_VERSION_HERE
diff --git a/kubernetes/config/docker/init/src/config/dcaegen2/heat/onap_dcae.yaml b/kubernetes/config/docker/init/src/config/dcaegen2/heat/onap_dcae.yaml
new file mode 100644
index 0000000000..31a81169a6
--- /dev/null
+++ b/kubernetes/config/docker/init/src/config/dcaegen2/heat/onap_dcae.yaml
@@ -0,0 +1,483 @@
+##########################################################################
+#
+#==================LICENSE_START==========================================
+#
+#
+# Copyright (c) 2017 AT&T Intellectual Property. All rights reserved.
+#
+# Licensed under the Apache License, Version 2.0 (the "License");
+# you may not use this file except in compliance with the License.
+# You may obtain a copy of the License at
+# http://www.apache.org/licenses/LICENSE-2.0
+#
+# Unless required by applicable law or agreed to in writing, software
+# distributed under the License is distributed on an "AS IS" BASIS,
+# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+# See the License for the specific language governing permissions and
+# limitations under the License.
+#
+#==================LICENSE_END============================================
+#
+# ECOMP is a trademark and service mark of AT&T Intellectual Property.
+#
+##########################################################################
+
+heat_template_version: 2015-10-15
+
+description: Heat template to install ONAP components
+
+##############
+# #
+# PARAMETERS #
+# #
+##############
+
+parameters:
+
+ ##############################################
+ # #
+ # Parameters used across all ONAP components #
+ # #
+ ##############################################
+
+ public_net_id:
+ type: string
+ description: The ID of the Public network for floating IP address allocation
+
+ public_net_name:
+ type: string
+ description: The name of the Public network referred by public_net_id
+
+ ubuntu_1404_image:
+ type: string
+ description: Name of the Ubuntu 14.04 image
+
+ ubuntu_1604_image:
+ type: string
+ description: Name of the Ubuntu 16.04 image
+
+ flavor_small:
+ type: string
+ description: Name of the Small Flavor supported by the cloud provider
+
+ flavor_medium:
+ type: string
+ description: Name of the Medium Flavor supported by the cloud provider
+
+ flavor_large:
+ type: string
+ description: Name of the Large Flavor supported by the cloud provider
+
+ vm_base_name:
+ type: string
+ description: Base name of ONAP VMs
+
+ key_name:
+ type: string
+ description: Public/Private key pair name
+
+ pub_key:
+ type: string
+ description: Public key to be installed on the compute instance
+
+ nexus_repo:
+ type: string
+ description: Complete URL for the Nexus repository.
+
+ nexus_docker_repo:
+ type: string
+ description: Complete URL for the Nexus repository for docker images.
+
+ nexus_username:
+ type: string
+ description: Nexus Repository username
+
+ nexus_password:
+ type: string
+ description: Nexus Repository Password
+
+ artifacts_version:
+ type: string
+ description: Artifacts version of ONAP components
+
+ openstack_tenant_id:
+ type: string
+ description: OpenStack tenant ID
+
+ openstack_tenant_name:
+ type: string
+ description: OpenStack tenant name (matching with the openstack_tenant_id)
+
+ openstack_username:
+ type: string
+ description: OpenStack username
+
+ openstack_api_key:
+ type: string
+ description: OpenStack password or API Key
+
+ keystone_url:
+ type: string
+ description: URL of OpenStack Keystone
+
+ cloud_env:
+ type: string
+ description: Cloud Provider Name in lower case
+
+ openstack_region:
+ type: string
+ description: Region where the DCAE controller will spin the VMs
+
+ ######################
+ # #
+ # Network parameters #
+ # #
+ ######################
+
+ dns_list:
+ type: comma_delimited_list
+ description: List of External DNS for OAM ONAP network
+
+ external_dns:
+ type: string
+ description: Public IP of the external DNS for ONAP network
+
+ dns_forwarder:
+ type: string
+ description: the forwarder address for setting up ONAP's private DNS server
+
+ oam_network_cidr:
+ type: string
+ description: CIDR of the OAM ONAP network
+
+ ### Private IP addresses ###
+ dns_ip_addr:
+ type: string
+ dcae_ip_addr:
+ type: string
+ aai1_k8s_ip_addr:
+ type: string
+ aai2_k8s_ip_addr:
+ type: string
+ mr_k8s_ip_addr:
+ type: string
+ policy_k8s_ip_addr:
+ type: string
+ sdc_k8s_ip_addr:
+ type: string
+ openo_k8s_ip_addr:
+ type: string
+
+ ###########################
+ # #
+ # Parameters used by DCAE #
+ # #
+ ###########################
+
+ dnsaas_config_enabled:
+ type: string
+ description: whether the DNSaaS configuration section is enabled
+
+ dnsaas_region:
+ type: string
+ description: the region of the cloud instance providing the Designate DNS as a Service
+
+ dnsaas_keystone_url:
+ type: string
+ description: the keystone URL of the cloud instance providing the Designate DNS as a Service
+
+ dnsaas_username:
+ type: string
+ description: the username of the cloud instance providing the Designate DNS as a Service
+
+ dnsaas_password:
+ type: string
+ description: the password of the cloud instance providing the Designate DNS as a Service
+
+ dnsaas_tenant_name:
+ type: string
+ description: the name of the tenant in the cloud instance providing the Designate DNS as a Service
+
+ dcae_keystone_url:
+ type: string
+ description: the keystone URL for DCAE to use (via MultiCloud)
+
+ dcae_private_key:
+ type: string
+ description: the private key of the key-apir used between the DCAE bootstrap container and DCAE VMs
+
+ dcae_public_key:
+ type: string
+ description: the prublic key of the key-apir used between the DCAE bootstrap container and DCAE VMs
+
+ dcae_centos_7_image:
+ type: string
+ description: the id/name of the CentOS 7 VM imange
+
+ dcae_domain:
+ type: string
+ description: the top level domain to register DCAE VMs (the zone will be random-str.dcae_domain)
+
+ dcae_docker:
+ type: string
+
+
+#############
+# #
+# RESOURCES #
+# #
+#############
+
+resources:
+ random-str:
+ type: OS::Heat::RandomString
+ properties:
+ length: 4
+
+ # Public key used to access ONAP components
+ vm_key:
+ type: OS::Nova::KeyPair
+ properties:
+ name:
+ str_replace:
+ template: base_rand
+ params:
+ base: { get_param: key_name }
+ rand: { get_resource: random-str }
+ public_key: { get_param: pub_key }
+ save_private_key: false
+
+
+ # ONAP security group
+ onap_sg:
+ type: OS::Neutron::SecurityGroup
+ properties:
+ name:
+ str_replace:
+ template: base_rand
+ params:
+ base: onap_sg
+ rand: { get_resource: random-str }
+ description: security group used by ONAP
+ rules:
+ # All egress traffic
+ - direction: egress
+ ethertype: IPv4
+ - direction: egress
+ ethertype: IPv6
+ # ingress traffic
+ # ICMP
+ - protocol: icmp
+ - protocol: udp
+ port_range_min: 1
+ port_range_max: 65535
+ - protocol: tcp
+ port_range_min: 1
+ port_range_max: 65535
+
+ # ONAP management private network
+ oam_onap:
+ type: OS::Neutron::Net
+ properties:
+ name:
+ str_replace:
+ template: oam_onap_rand
+ params:
+ rand: { get_resource: random-str }
+
+ oam_onap_subnet:
+ type: OS::Neutron::Subnet
+ properties:
+ name:
+ str_replace:
+ template: oam_onap_rand
+ params:
+ rand: { get_resource: random-str }
+ network_id: { get_resource: oam_onap }
+ cidr: { get_param: oam_network_cidr }
+ dns_nameservers: { get_param: dns_list }
+
+ router:
+ type: OS::Neutron::Router
+ properties:
+ external_gateway_info:
+ network: { get_param: public_net_id }
+
+ router_interface:
+ type: OS::Neutron::RouterInterface
+ properties:
+ router_id: { get_resource: router }
+ subnet_id: { get_resource: oam_onap_subnet }
+
+ # DCAE GEN 2 Controller instantiation
+ dcae_c_private_port:
+ type: OS::Neutron::Port
+ properties:
+ network: { get_resource: oam_onap }
+ fixed_ips: [{"subnet": { get_resource: oam_onap_subnet }, "ip_address": { get_param: dcae_ip_addr }}]
+
+ dcae_c_floating_ip:
+ type: OS::Neutron::FloatingIP
+ properties:
+ floating_network_id: { get_param: public_net_id }
+ port_id: { get_resource: dcae_c_private_port }
+
+ dcae_c_vm:
+ type: OS::Nova::Server
+ properties:
+ image: { get_param: ubuntu_1604_image }
+ flavor: { get_param: flavor_small }
+ name:
+ str_replace:
+ template: base-dcae-bootstrap
+ params:
+ base: { get_param: vm_base_name }
+ key_name: { get_resource: vm_key }
+ networks:
+ - port: { get_resource: dcae_c_private_port }
+ #security_groups:
+ # - { get_resource: onap_sg }
+ user_data_format: RAW
+ user_data:
+ str_replace:
+ params:
+ __rand_str__: { get_resource: random-str }
+ # repo related
+ __artifacts_version__: { get_param: artifacts_version }
+ __docker_version__: { get_param: dcae_docker }
+ __nexus_repo__: { get_param: nexus_repo }
+ __nexus_docker_repo__: { get_param: nexus_docker_repo }
+ __nexus_username__: { get_param: nexus_username }
+ __nexus_password__: { get_param: nexus_password }
+ # conf for the ONAP environment where the DCAE bootstrap vm/conatiner runs
+ __mac_addr__: { get_attr: [dcae_c_private_port, mac_address] }
+ __dcae_ip_addr__: { get_param: dcae_ip_addr }
+ __dcae_float_ip__: { get_attr: [dcae_c_floating_ip, floating_ip_address] }
+ __dns_ip_addr__: { get_param: dns_ip_addr }
+ __external_dns__: { get_param: external_dns }
+ __dns_forwarder__: { get_param: dns_forwarder }
+ __dcae_domain__: { get_param: dcae_domain }
+ # conf for VMs DCAE is to bringup
+ __openstack_keystone_url__: { get_param: keystone_url }
+ __dcae_keystone_url__: { get_param: dcae_keystone_url }
+ __dcaeos_cloud_env__: { get_param: cloud_env }
+ __dcaeos_keystone_url__: { get_param: dcae_keystone_url }
+ __dcaeos_region__: { get_param: openstack_region }
+ __dcaeos_tenant_id__: { get_param: openstack_tenant_id }
+ __dcaeos_tenant_name__: { get_param: openstack_tenant_name }
+ __dcaeos_security_group__:
+ str_replace:
+ template: 'onap_sg_rand'
+ params:
+ rand: { get_resource: random-str }
+ #__dcaeos_security_group__: { get_attr: [onap_sg, name] }
+ __dcaeos_username__: { get_param: openstack_username }
+ __dcaeos_password__: { get_param: openstack_api_key }
+ __dcaeos_key_name__: { get_resource: vm_key }
+ __dcaeos_public_key__: { get_param: dcae_public_key }
+ __dcaeos_private_key__: { get_param: dcae_private_key }
+ __dcaeos_private_network_name__: { get_attr: [oam_onap, name] }
+ __dcaeos_public_network_name__: { get_param: public_net_name }
+ __dcaeos_ubuntu_1604_image__: { get_param: ubuntu_1604_image }
+ __dcaeos_centos_7_image__: { get_param: dcae_centos_7_image }
+ __dcaeos_flavor_id__: { get_param: flavor_medium }
+ __dcaeos_flavor_id_cdap__: { get_param: flavor_large }
+ __dcaeos_dnsaas_config_enabled__: { get_param: dnsaas_config_enabled }
+ __dcaeos_dnsaas_region__: { get_param: dnsaas_region }
+ __dcaeos_dnsaas_keystone_url__: { get_param: dnsaas_keystone_url }
+ __dnsaas_tenant_name__: { get_param: dnsaas_tenant_name }
+ __dcaeos_dnsaas_username__: { get_param: dnsaas_username }
+ __dcaeos_dnsaas_password__: { get_param: dnsaas_password }
+ # fixed private IPs
+ __mr_ip_addr__: { get_param: mr_k8s_ip_addr }
+ __policy_ip_addr__: { get_param: policy_k8s_ip_addr }
+ __sdc_ip_addr__: { get_param: sdc_k8s_ip_addr }
+ __openo_ip_addr__: { get_param: openo_k8s_ip_addr }
+ __aai1_ip_addr__: { get_param: aai1_k8s_ip_addr }
+ __aai2_ip_addr__: { get_param: aai2_k8s_ip_addr }
+ # floating IPs
+ __dns_floating_ip_addr__: { get_param: dns_ip_addr }
+ __aai1_floating_ip_addr__: { get_param: aai1_k8s_ip_addr }
+ __aai2_floating_ip_addr__: { get_param: aai1_k8s_ip_addr }
+ __mrouter_floating_ip_addr__: { get_param: mr_k8s_ip_addr }
+ __sdc_floating_ip_addr__: { get_param: sdc_k8s_ip_addr }
+ __policy_floating_ip_addr__: { get_param: policy_k8s_ip_addr }
+ __openo_floating_ip_addr__: { get_param: openo_k8s_ip_addr }
+ __dcae_c_floating_ip_addr__: { get_attr: [dcae_c_floating_ip, floating_ip_address] }
+
+ template: |
+ #!/bin/bash
+
+ # Create configuration files
+ mkdir -p /opt/config
+ echo "__rand_str__" > /opt/config/dcae_zone.txt
+ echo "__rand_str__" > /opt/config/rand_str.txt
+ # repo related
+ echo "__docker_version__" > /opt/config/docker_version.txt
+ echo "__artifacts_version__" > /opt/config/artifacts_version.txt
+ echo "__nexus_repo__" > /opt/config/nexus_repo.txt
+ echo "__nexus_docker_repo__" > /opt/config/nexus_docker_repo.txt
+ echo "__nexus_username__" > /opt/config/nexus_username.txt
+ echo "__nexus_password__" > /opt/config/nexus_password.txt
+ echo "__gerrit_branch__" > /opt/config/gerrit_branch.txt
+ # conf for the ONAP environment where the DCAE bootstrap vm/conatiner runs
+ echo "__mac_addr__" > /opt/config/mac_addr.txt
+ echo "__dcae_ip_addr__" > /opt/config/dcae_ip_addr.txt
+ echo "__dcae_float_ip__" > /opt/config/dcae_float_ip.txt
+ echo "__dns_ip_addr__" > /opt/config/dns_ip_addr.txt
+ echo "__external_dns__" > /opt/config/external_dns.txt
+ echo "__dns_forwarder__" > /opt/config/dns_forwarder.txt
+ echo "__dcae_domain__" > /opt/config/dcae_domain.txt
+ # conf for the OpenStack env where DCAE is deployed
+ echo "__openstack_keystone_url__" > /opt/config/openstack_keystone_url.txt
+ echo "__dcaeos_cloud_env__" > /opt/config/cloud_env.txt
+ echo "__dcaeos_keystone_url__" > /opt/config/keystone_url.txt
+ echo "__dcaeos_region__" > /opt/config/openstack_region.txt
+ echo "__dcaeos_tenant_id__" > /opt/config/tenant_id.txt
+ echo "__dcaeos_tenant_name__" > /opt/config/tenant_name.txt
+ echo "__dcaeos_username__" > /opt/config/openstack_user.txt
+ echo "__dcaeos_password__" > /opt/config/openstack_password.txt
+ echo "__dcaeos_key_name__" > /opt/config/key_name.txt
+ echo "__dcaeos_public_key__" > /opt/config/pub_key.txt
+ echo "__dcaeos_private_key__" > /opt/config/priv_key
+ echo "__dcaeos_private_network_name__" > /opt/config/openstack_private_network_name.txt
+ echo "__dcaeos_public_network_name__" > /opt/config/public_net_name.txt
+ echo "__dcaeos_public_network_name__" > /opt/config/public_net_id.txt
+ echo "__dcaeos_ubuntu_1604_image__" > /opt/config/ubuntu_1604_image.txt
+ echo "__dcaeos_centos_7_image__" > /opt/config/centos_7_image.txt
+ echo "__dcaeos_security_group__" > /opt/config/security_group.txt
+ echo "__dcaeos_flavor_id__" > /opt/config/flavor_id.txt
+ echo "__dcaeos_flavor_id_cdap__" > /opt/config/flavor_id_cdap.txt
+ echo "__dcaeos_dnsaas_config_enabled__" > /opt/config/dnsaas_config_enabled.txt
+ echo "__dcaeos_dnsaas_region__" > /opt/config/dnsaas_region.txt
+ echo "__dcaeos_dnsaas_keystone_url__" > /opt/config/dnsaas_keystone_url.txt
+ echo "__dnsaas_tenant_name__" > /opt/config/dnsaas_tenant_name.txt
+ echo "__dcaeos_dnsaas_username__" > /opt/config/dnsaas_username.txt
+ echo "__dcaeos_dnsaas_password__" > /opt/config/dnsaas_password.txt
+ # fixed private IP addresses of other ONAP components
+ echo "__mr_ip_addr__" > /opt/config/mr_ip_addr.txt
+ echo "__policy_ip_addr__" > /opt/config/policy_ip_addr.txt
+ echo "__sdc_ip_addr__" > /opt/config/sdc_ip_addr.txt
+ echo "__openo_ip_addr__" > /opt/config/openo_ip_addr.txt
+ echo "__aai1_ip_addr__" > /opt/config/aai1_ip_addr.txt
+ echo "__aai2_ip_addr__" > /opt/config/aai2_ip_addr.txt
+ # floating IPs
+ echo "__dns_floating_ip_addr__" > /opt/config/dns_floating_ip_addr.txt
+ echo "__aai1_floating_ip_addr__" > /opt/config/aai1_floating_ip_addr.txt
+ echo "__aai2_floating_ip_addr__" > /opt/config/aai2_floating_ip_addr.txt
+ echo "__mrouter_floating_ip_addr__" > /opt/config/mrouter_floating_ip_addr.txt
+ echo "__sdc_floating_ip_addr__" > /opt/config/sdc_floating_ip_addr.txt
+ echo "__policy_floating_ip_addr__" > /opt/config/policy_floating_ip_addr.txt
+ echo "__openo_floating_ip_addr__" > /opt/config/openo_floating_ip_addr.txt
+ echo "__dcae_c_floating_ip_addr__" > /opt/config/dcae_c_floating_ip_addr.txt
+
+ # Download and run install script
+ curl -k __nexus_repo__/org.onap.demo/boot/__artifacts_version__/dcae2_install.sh -o /opt/dcae2_install.sh
+ cd /opt
+ chmod +x dcae2_install.sh
+ ./dcae2_install.sh > /tmp/dcae2_install.log 2>&1
+
+outputs:
+ dcae_floating_ip:
+ description: DCAE Boostrap container external IP Address
+ value: { get_attr: [ dcae_c_floating_ip, floating_ip_address ] } \ No newline at end of file